感觉这题可以模板化。

听说spfa死了,所以要练堆优化dijkstra。

首先对$x_{1},y_{1},x_{2},y_{2}$各跑一遍最短路,然后扫一遍所有边看看是不是同时在两个点的最短路里面,如果是的话就把这条边加到一张新图中去,因为最短路一定没有环,所以最后造出来的这张新图一定是一个$DAG$,dp一遍求最长链即为答案。

考虑一下怎么判断一条边是否在最短路里,设这条边连接的两个点是$x$,$y$,边权是$v$,如果它在最短路里面,那么有$dis(x_{1}, x) + v + dis(y_{1}, y) == dis(x_{1}, y_{1})$并且$dis(x_{2}, x) + v + dis(y_{2}, y) == dis(x_{2}, y_{2})$,注意第二个条件中$x$和$y$可以交换。加边的时候注意维持一下$DAG$的形态,可以把$x$和$y$到$x_{1}$的距离小的向距离大的连边。

时间复杂度$O(nlogn)$,堆优化dij是瓶颈。

感觉写得很长。

Code:

#include <cstdio>
#include <cstring>
#include <queue>
#include <iostream>
using namespace std;
typedef pair <int, int> pin; const int N = ;
const int M = 3e6 + ;
const int inf = 0x3f3f3f3f; int n, m, inx[M], iny[M], inv[M], deg[N], f[N], ans = ;
int c1, c2, c3, c4, tot = , head[N], dis[N], d[][N];
bool vis[N]; struct Edge {
int to, nxt, val;
} e[M << ]; inline void add(int from, int to, int val) {
e[++tot].to = to;
e[tot].val = val;
e[tot].nxt = head[from];
head[from] = tot;
} inline void read(int &X) {
X = ; char ch = ; int op = ;
for(; ch > ''|| ch < ''; ch = getchar())
if(ch == '-') op = -;
for(; ch >= '' && ch <= ''; ch = getchar())
X = (X << ) + (X << ) + ch - ;
X *= op;
} inline void swap(int &x, int &y) {
int t = x; x = y; y = t;
} priority_queue <pin> Q;
void dij(int st) {
memset(dis, 0x3f, sizeof(dis));
memset(vis, , sizeof(vis));
Q.push(pin(dis[st] = , st));
for(; !Q.empty(); ) {
int x = Q.top().second; Q.pop();
if(vis[x]) continue;
vis[x] = ;
for(int i = head[x]; i; i = e[i].nxt) {
int y = e[i].to;
if(dis[y] > dis[x] + e[i].val) {
dis[y] = dis[x] + e[i].val;
Q.push(pin(-dis[y], y));
}
}
}
} inline void chkMax(int &x, int y) {
if(y > x) x = y;
} int dfs(int x) {
if(vis[x]) return f[x];
vis[x] = ;
int res = ;
for(int i = head[x]; i; i = e[i].nxt) {
int y = e[i].to;
chkMax(res, dfs(y) + e[i].val);
}
return f[x] = res;
} int main() {
read(n), read(m), read(c1), read(c2), read(c3), read(c4);
for(int i = ; i <= m; i++) {
read(inx[i]), read(iny[i]), read(inv[i]);
add(inx[i], iny[i], inv[i]), add(iny[i], inx[i], inv[i]);
} dij(c1); memcpy(d[], dis, sizeof(d[]));
dij(c2); memcpy(d[], dis, sizeof(d[]));
dij(c3); memcpy(d[], dis, sizeof(d[]));
dij(c4); memcpy(d[], dis, sizeof(d[])); /* for(int i = 1; i <= n; i++)
printf("%d ", d[0][i]);
printf("\n");
for(int i = 1; i <= n; i++)
printf("%d ", d[1][i]);
printf("\n");
for(int i = 1; i <= n; i++)
printf("%d ", d[2][i]);
printf("\n");
for(int i = 1; i <= n; i++)
printf("%d ", d[3][i]);
printf("\n"); */ tot = ; memset(head, , sizeof(head));
for(int i = ; i <= m; i++) {
int x = inx[i], y = iny[i], v = inv[i];
if(d[][x] + v + d[][y] == d[][c2])
if(d[][y] + v + d[][x] == d[][c4] || d[][x] + v + d[][y] == d[][c4]) {
if(d[][x] < d[][y]) {
add(x, y, v);
deg[y]++;
} else {
add(y, x, v);
deg[x]++;
}
} swap(x, y);
if(d[][x] + v + d[][y] == d[][c2])
if(d[][y] + v + d[][x] == d[][c4] || d[][x] + v + d[][y] == d[][c4]) {
if(d[][x] < d[][y]) {
add(x, y, v);
deg[y]++;
} else {
add(y, x, v);
deg[x]++;
}
}
} memset(vis, , sizeof(vis));
for(int i = ; i <= n; i++)
if(deg[i] == && !vis[i]) dfs(i); /* for(int i = 1; i <= n; i++)
printf("%d ", f[i]);
printf("\n"); */ for(int i = ; i <= n; i++)
chkMax(ans, f[i]); printf("%d\n", ans);
return ;
}

Luogu 2149 [SDOI2009]Elaxia的路线的更多相关文章

  1. Luogu P2149 [SDOI2009]Elaxia的路线(最短路+记忆化搜索)

    P2149 [SDOI2009]Elaxia的路线 题意 题目描述 最近,\(Elaxia\)和\(w**\)的关系特别好,他们很想整天在一起,但是大学的学习太紧张了,他们必须合理地安排两个人在一起的 ...

  2. 洛谷 2149 [SDOI2009]Elaxia的路线

    题目描述 最近,Elaxia和w的关系特别好,他们很想整天在一起,但是大学的学习太紧张了,他们 必须合理地安排两个人在一起的时间.Elaxia和w每天都要奔波于宿舍和实验室之间,他们 希望在节约时间的 ...

  3. BZOJ1880或洛谷2149 [SDOI2009]Elaxia的路线

    BZOJ原题链接 洛谷原题链接 显然最长公共路径是最短路上的一条链. 我们可以把最短路经过的边看成有向边,那么组成的图就是一张\(DAG\),这样题目要求的即是两张\(DAG\)重合部分中的最长链. ...

  4. Luogu P2149 [SDOI2009]Elaxia的路线 | 图论

    题目链接 题解: 题面中给了最简洁清晰的题目描述:"求无向图中,两对点间最短路的最长公共路径". 对于这个问题我们可以先考虑图中的哪些边对这两对点的最短路产生了贡献. 比如说下面这 ...

  5. BZOJ 1880: [Sdoi2009]Elaxia的路线( 最短路 + dp )

    找出同时在他们最短路上的边(dijkstra + dfs), 组成新图, 新图DAG的最长路就是答案...因为两人走同一条路但是不同方向也可以, 所以要把一种一个的s,t换一下再更新一次答案 ---- ...

  6. 【BZOJ1880】[Sdoi2009]Elaxia的路线(最短路)

    [BZOJ1880][Sdoi2009]Elaxia的路线(最短路) 题面 BZOJ 洛谷 题解 假装我们知道了任意两点间的最短路,那么我们怎么求解答案呢? 不难发现公共路径一定是一段连续的路径(如果 ...

  7. 洛谷 P2149 [SDOI2009]Elaxia的路线 解题报告

    P2149 [SDOI2009]Elaxia的路线 题目描述 最近,Elaxia和w**的关系特别好,他们很想整天在一起,但是大学的学习太紧张了,他们 必须合理地安排两个人在一起的时间. Elaxia ...

  8. 【BZOJ 1880】 [Sdoi2009]Elaxia的路线 (最短路树)

    1880: [Sdoi2009]Elaxia的路线 Description 最近,Elaxia和w**的关系特别好,他们很想整天在一起,但是大学的学习太紧张了,他们 必须合理地安排两个人在一起的时间. ...

  9. BZOJ1880: [Sdoi2009]Elaxia的路线(最短路)

    1880: [Sdoi2009]Elaxia的路线 Time Limit: 4 Sec  Memory Limit: 64 MBSubmit: 2049  Solved: 805 题目链接:https ...

随机推荐

  1. vmware centos 连网方式

    1.自动获取IP地址 虚拟机使用桥接模式,相当于连接到物理机的网络里,物理机网络有DHCP服务器自动分配IP地址. #dhclient 自动获取ip地址命令 #ifconfig 查询系统里网卡信息,i ...

  2. 使用Visio画UML模型

    Microsoft Office Visio“UML 模型图” 模板为创建复杂软件系统的面向对象的模型 (模型:建模系统的一种抽象表示,它从特定的视角并在某一抽象级别上指定建模系统.) 提供全面的支持 ...

  3. Java 输入参数并求和

    题目要求: 输入若干的参数,编写一个程序求出参数的和: 程序流程: 代码: 例子:

  4. Codeforces 802 ABC. Heidi and Library

    题目大意 你需要保证第\(i\)天时有第\(a_i\)种书.你可以在任何一天买书,买第\(i\)种书的代价为\(c_i\). 你最多同时拥有\(k\)本书,如果此时再买书,则必须先扔掉已拥有的一本书. ...

  5. hl7 v2.X 版本中RSP_K23消息的构造

    RSP_K23消息有MSH, MSA, ERR, QAK, QPD, PID几个segment,其中ERR,PID为可选. 1. 当MSA有err时,ERR段填充出错的详细信息. 2. 当MSA为AA ...

  6. 在centos阿里云服务器上安装配置php运行环境 安装php7

    http://blog.csdn.net/kesixin/article/details/72882469 单独安装php7 http://blog.csdn.net/tang05709/articl ...

  7. phpBB安装

    要测试一个网站的安全性,不得不安装一个网站.常用的Hello World!不行了,找了个phpBB安装.非常方便,记录一下安装过程. 下载phpBB 下载地址:http://tianjin.mycod ...

  8. qt在linux下使用open,write,close等文件操作

    正常在linux下使用的文件操作函数为: #include <fcntl.h>fd = open(“path”,O_RDWR|O_NONBLOCK); 但是在qt中,需要使用: #incl ...

  9. PHPExcel如何把该列的值设置为文本无科学计数?

                    $obj_sheet->setCellValueExplicit($cells[$_counter].$i, (isset($val[$_value_key]) ...

  10. HDU4006(小根堆)

    The kth great number Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65768/65768 K (Java/Oth ...